'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _createStateMutext2 = require('./createStateMutext');

var _createStateMutext3 = _interopRequireDefault(_createStateMutext2);

var _getBitmaskTable = require('./getBitmaskTable');

var _getBitmaskTable2 = _interopRequireDefault(_getBitmaskTable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MAX_SIGNED_31_BIT_INT = 1073741823;

var parseNames = function parseNames(nameStr) {
  return nameStr.split(/\s*,\s*/);
};

var createObservableMutext = function createObservableMutext(preload, tableConfs, gEnhancer) {
  var tableNames = Object.keys(tableConfs).sort();
  var bitmaskTable = (0, _getBitmaskTable2.default)(tableNames);

  var calcChangedBits = function calcChangedBits(a, b) {
    var result = tableNames.reduce(function (r, name) {
      // eslint-disable-next-line no-bitwise
      return a[name] !== b[name] ? r | bitmaskTable[name] : r;
    }, 0);
    // changed on somethings that not in names
    return result === 0 && a !== b ? MAX_SIGNED_31_BIT_INT : result;
  };

  var _createStateMutext = (0, _createStateMutext3.default)(preload, calcChangedBits, gEnhancer),
      Provider = _createStateMutext.Provider,
      Consumer = _createStateMutext.Consumer;

  var getObservedBits = function getObservedBits(observe) {
    // observe should be string to recognition
    return parseNames(observe).reduce(function (r, name) {
      // eslint-disable-next-line no-bitwise
      return r | bitmaskTable[name];
    }, 0);
  };

  var ObservableMutextConsumer = function (_Component) {
    _inherits(ObservableMutextConsumer, _Component);

    function ObservableMutextConsumer() {
      var _temp, _this, _ret;

      _classCallCheck(this, ObservableMutextConsumer);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.observedBits = getObservedBits(_this.props.observe), _temp), _possibleConstructorReturn(_this, _ret);
    }

    ObservableMutextConsumer.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      if (this.props.observe !== nextProps.observe) {
        this.observedBits = getObservedBits(nextProps.observe);
      }
    };

    ObservableMutextConsumer.prototype.render = function render() {
      return (0, _react.createElement)(Consumer, _extends({}, this.props, {
        observedBits: this.observedBits
      }));
    };

    return ObservableMutextConsumer;
  }(_react.Component);

  return { Provider: Provider, Consumer: ObservableMutextConsumer };
};

exports.default = createObservableMutext;