'use strict';

exports.__esModule = true;
exports.wrapUpdaterScope = undefined;

var _createStateMutext2 = require('./createStateMutext');

var _createStateMutext3 = _interopRequireDefault(_createStateMutext2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var wrapUpdaterScope = exports.wrapUpdaterScope = function wrapUpdaterScope(updater, stateKey) {
  var _ref2;

  return typeof updater === 'function' ? function (prevState, props) {
    var _ref;

    return _ref = {}, _ref[stateKey] = updater(prevState[stateKey], props), _ref;
  } : (_ref2 = {}, _ref2[stateKey] = updater, _ref2);
};

var createValueMutext = function createValueMutext(confDefaultValue, calcChangedBits, confEnhancer) {
  var _createStateMutext = (0, _createStateMutext3.default)(confDefaultValue, calcChangedBits ? function (_ref3, _ref4) {
    var a = _ref3.value;
    var b = _ref4.value;
    return calcChangedBits(a, b);
  } : undefined, confEnhancer),
      Provider = _createStateMutext.Provider,
      Consumer = _createStateMutext.Consumer;

  var ValueMutextProvider = function (_Provider) {
    _inherits(ValueMutextProvider, _Provider);

    function ValueMutextProvider() {
      _classCallCheck(this, ValueMutextProvider);

      return _possibleConstructorReturn(this, _Provider.apply(this, arguments));
    }

    ValueMutextProvider.prototype.getStateFromValue = function getStateFromValue(value) {
      return { value: value };
    };

    ValueMutextProvider.prototype.getStateUpdater = function getStateUpdater(updater) {
      return wrapUpdaterScope(updater, 'value');
    };

    return ValueMutextProvider;
  }(Provider);

  return { Provider: ValueMutextProvider, Consumer: Consumer };
};

exports.default = createValueMutext;