'use strict';

exports.__esModule = true;
exports.wrapUpdateField = undefined;

var _react = require('react');

var _createReactContext2 = require('create-react-context');

var _createReactContext3 = _interopRequireDefault(_createReactContext2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var wrapUpdateField = exports.wrapUpdateField = function wrapUpdateField(updater, stateKey) {
  var _ref2;

  return typeof updater === 'function' ? function (prevState, props) {
    var _ref;

    return _ref = {}, _ref[stateKey] = updater(prevState[stateKey], props), _ref;
  } : (_ref2 = {}, _ref2[stateKey] = updater, _ref2);
};

var createMutableContext = function createMutableContext(globalDefaultValue, calcChangedBits, defaultEnhancer) {
  var _createReactContext = (0, _createReactContext3.default)(globalDefaultValue, calcChangedBits ? function (_ref3, _ref4) {
    var a = _ref3.value;
    var b = _ref4.value;
    return calcChangedBits(a, b);
  } : null),
      Provider = _createReactContext.Provider,
      Consumer = _createReactContext.Consumer;

  var MutableProvider = function (_Component) {
    _inherits(MutableProvider, _Component);

    function MutableProvider(props) {
      _classCallCheck(this, MutableProvider);

      var _this = _possibleConstructorReturn(this, _Component.call(this, props));

      _initialiseProps.call(_this);

      var value = [props.value, props.defaultValue, globalDefaultValue].find(function (a) {
        return a !== undefined;
      });
      var state = _this.getStateFromValue(value);

      // basic enhancer
      // TODO ensure state is object?
      state.set = _this.set;

      // global-level enhancer
      if (defaultEnhancer) state = defaultEnhancer(state, props);
      // provider-level enhancer
      var enhancer = props.enhancer;

      if (enhancer) state = enhancer(state, props);

      _this.state = state;
      return _this;
    }

    MutableProvider.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
      if (nextProps.value !== this.props.value) {
        this.setState(this.getStateFromValue(nextProps.value));
      }
    };

    // allow override to change ctx to value relationship


    MutableProvider.prototype.getStateFromValue = function getStateFromValue(value) {
      return { value: value };
    };

    MutableProvider.prototype.getStateUpdater = function getStateUpdater(updater) {
      return wrapUpdateField(updater, 'value');
    };

    MutableProvider.prototype.render = function render() {
      return (0, _react.createElement)(Provider, { value: this.state }, this.props.children);
    };

    return MutableProvider;
  }(_react.Component);

  var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.set = function (newValue, callback) {
      var _props = _this2.props,
          value = _props.value,
          onChange = _props.onChange;
      // this is Uncontrolled

      if (value === undefined) _this2.setState(_this2.getStateUpdater(newValue), callback);
      // always fire onChange for persist usage
      if (onChange) onChange(newValue, callback);
    };
  };

  return { Provider: MutableProvider, Consumer: Consumer };
};

exports.default = createMutableContext;