'use strict';

exports.__esModule = true;

var _mutableContext2 = require('./mutableContext');

var _mutableContext3 = _interopRequireDefault(_mutableContext2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var stateMutableContext = function stateMutableContext(gDefaultValue, calcChangedBits, gEnhancer) {
  var _mutableContext = (0, _mutableContext3.default)(gDefaultValue, calcChangedBits, gEnhancer),
      Provider = _mutableContext.Provider,
      Consumer = _mutableContext.Consumer;

  var StateMutableProvider = function (_Provider) {
    _inherits(StateMutableProvider, _Provider);

    function StateMutableProvider() {
      _classCallCheck(this, StateMutableProvider);

      return _possibleConstructorReturn(this, _Provider.apply(this, arguments));
    }

    StateMutableProvider.prototype.getStateFromValue = function getStateFromValue(value) {
      // prevent overwrite set or enhanced functions? in componentWillReceiveProps
      return value || {};
    };

    StateMutableProvider.prototype.getStateUpdater = function getStateUpdater(updater) {
      // prevent overwrite set or enhanced functions? in set function
      return updater;
    };

    return StateMutableProvider;
  }(Provider);

  return { Provider: StateMutableProvider, Consumer: Consumer };
};

exports.default = stateMutableContext;